"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isSelfDelegator = exports.getDelegatorAddressFromOpAddr = exports.checkNumber = void 0;

var bech32 = _interopRequireWildcard(require("bech32"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var MAX_INT64 = Math.pow(2, 63);
/**
 * validate the input number.
 * @param {Number} value
 */

var checkNumber = function checkNumber(value) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "input number";

  if (value <= 0) {
    throw new Error("".concat(name, " should be a positive number"));
  }

  if (MAX_INT64 <= value) {
    throw new Error("".concat(name, " should be less than 2^63"));
  }
};

exports.checkNumber = checkNumber;

var getDelegatorAddressFromOpAddr = function getDelegatorAddressFromOpAddr(operatorAddr, prefix) {
  var address = bech32.decode(operatorAddr);
  return bech32.encode(prefix, address.words);
};

exports.getDelegatorAddressFromOpAddr = getDelegatorAddressFromOpAddr;

var isSelfDelegator = function isSelfDelegator(operator, delegator, prefix) {
  var derivedDelegator = getDelegatorAddressFromOpAddr(operator, prefix);
  return derivedDelegator === delegator;
};

exports.isSelfDelegator = isSelfDelegator;